/* interix.h -- User functions for run-time dynamic loading.
   Copyright (C) 1995, 1996 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */


/*Compare the contents of this file with interix-internal.h
 *All macros should be in sync. This is needed till we have complete 
 *infrastructure in ptherad.h to expose this for ISVs
 */

#ifndef _PTHREAD_INTERNAL_H
#define _PTHREAD_INTERNAL_H

#include <pthread.h>
extern int beThreadSafe;
#define DEF_BETHREADSAFE (beThreadSafe)
#define PTHREAD_SUCCESS 0

#define PTHREAD_MUTEX_LOCK_IN(mutex) \
	DEF_BETHREADSAFE ? pthread_mutex_lock(mutex) : PTHREAD_SUCCESS
#define PTHREAD_MUTEX_UNLOCK_IN(mutex) \
	DEF_BETHREADSAFE ? pthread_mutex_unlock(mutex) : PTHREAD_SUCCESS

#endif /*interix.h*/
